#2955 closed defect (fixed)

Backport libdl fixes to the 4.11 branch.

Reported by: Chris Johns Owned by: chrisj@…
Priority: high Milestone: 4.11.2
Component: lib/dl Version: 4.11
Severity: normal Keywords:
Cc: Blocked By:
Blocking:

Description

Back port the patches from tickets #2754 and #2767 to the 4.11 branch.

Change History (5)

comment:1 Changed on Mar 29, 2017 at 6:33:17 AM by Chris Johns

The testing on the 4.11 branch has exposed a bug in the 4.12 fixes for C++ exceptions. The ticket #2959 tracks the fix. This ticket will track that fix on the 4.11 branch.

comment:2 Changed on Mar 31, 2017 at 2:57:18 AM by Chris Johns <chrisj@…>

In bba48d9/rtems:

libdl: Support link ordered loading of ELF sections.

The ARM C++ exception ABI uses an address ordered index table to
locate the correct frame data and this requires the EXIDX sections are
loaded in the order the order the matching text is loaded.

The EXIDX sections set the SHF_LINK_ORDER flag and link field. This patch
adds support to load those flagged sections in the linked-to section
order.

Updates #2955.
Closes #2959

comment:3 Changed on Apr 4, 2017 at 12:47:09 AM by Chris Johns

Milestone: 4.11.34.11.2

Move this ticket to the 4.11.2 release and I will create 4.11.2-rc2. If there are problems we can move the 4.11.3 milestone forward.

comment:4 Changed on Apr 4, 2017 at 3:28:23 AM by Chris Johns <chrisj@…>

In 4b69a14/rtems-source-builder:

4.11/sparc: Add the binutils-2.26 SPARC R_SPARC_32 reloc fix.

See https://sourceware.org/bugzilla/show_bug.cgi?id=20803.

This fix is needed to support C++ exceptions in dynamically loaded
code.

Updates #2955.

comment:5 Changed on Apr 4, 2017 at 3:30:34 AM by Chris Johns

Resolution: fixed
Status: assignedclosed

Code backported to the 4.11 branch.

Note: See TracTickets for help on using tickets.